package com.keyborad.theme.trendyborad.trendylistutils;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.keyborad.theme.trendyborad.R;
import com.keyborad.theme.trendyborad.bean.BeanDetails;
import com.keyborad.theme.trendyborad.trendycallback.TrendyOnItemClickCallback;
import com.keyborad.theme.trendyborad.trendyuiactivity.TrendySetKeyboardActivity;
import com.bumptech.glide.Glide;
import com.keyborad.theme.trendyborad.trendyutils.TrendyCommon;

import java.util.ArrayList;
import java.util.List;

public class TrendySetKeyboardMoreAdapter extends RecyclerView.Adapter<TrendySetKeyboardMoreAdapter.ForYouViewHolder> {

    private Context mContext;
    private List<BeanDetails> mList = new ArrayList<>();

    private TrendyOnItemClickCallback mCallBack;

    public TrendySetKeyboardMoreAdapter(Context context) {
        mContext = context;
    }

    public void setForYouList(List<BeanDetails> list) {
        this.mList = list;
        notifyDataSetChanged();
    }
    public void setClickAction(TrendyOnItemClickCallback callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.adapter_set_keyboard_more, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        BeanDetails beanDetails = mList.get(position);
        String thumbGif = beanDetails.getThumbGif();
        String thumb = beanDetails.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            TrendyCommon.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext).load(thumb).into(holder.itemImg);
        }

        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, TrendySetKeyboardActivity.class);
                intentApply.putExtra(TrendySetKeyboardActivity.SOURCE_KEY, beanDetails);
                intentApply.putExtra(TrendySetKeyboardActivity.DISPLAY_URL_KEY, beanDetails.getImgPath());
                intentApply.putExtra(TrendySetKeyboardActivity.ZIP_URL_KEY, beanDetails.getZipPath());
                intentApply.putExtra(TrendySetKeyboardActivity.NAME_KEY, beanDetails.getTitleName());
                intentApply.putExtra(TrendySetKeyboardActivity.GIF_KEY, beanDetails.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(TrendySetKeyboardActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);
                if (mCallBack != null) {
                    mCallBack.OnItemClickListener();
                }

            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private ImageView itemImg;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            itemImg = itemView.findViewById(R.id.imPreview);

        }

    }

//    private void loadWepJif(String webpGifUrl,ImageView view){
//        Glide.with(mContext).load(webpGifUrl).addListener(new RequestListener<Drawable>() {
//            @Override
//            public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
//                return false;
//            }
//
//            @Override
//            public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
//               if(resource instanceof WebpDrawable){
//                   WebpDrawable webpDrawable = (WebpDrawable) resource;
//                   webpDrawable.setLoopCount(LOOP_FOREVER);
//               }
//
//                return false;
//            }
//        }).into(view);
//    }
}
